@file:Suppress("DEPRECATION")

package com.taiwanmobile.pt.adp.mediation

import com.google.android.gms.ads.AdRequest
import com.google.android.gms.ads.mediation.customevent.CustomEventNativeListener
import com.google.android.gms.ads.nativead.NativeAdOptions
import com.taiwanmobile.pt.adp.view.TWMAd
import com.taiwanmobile.pt.adp.view.TWMAdRequest
import com.taiwanmobile.pt.adp.view.TWMAdViewListener
import com.taiwanmobile.pt.adp.view.TWMNativeAd

@Suppress("DEPRECATION")
class TAmediaNativeEventForwarder(private val listener: CustomEventNativeListener,
                                  private val options: NativeAdOptions
) : TWMAdViewListener {
    override fun onDismissScreen(ad: TWMAd) {}

    override fun onFailedToReceiveAd(ad: TWMAd, errorCode: TWMAdRequest.ErrorCode) {
        listener.onAdFailedToLoad(AdRequest.ERROR_CODE_NO_FILL)
    }

    override fun onLeaveApplication(ad: TWMAd) {
        listener.onAdClicked()
        listener.onAdLeftApplication()
    }

    override fun onPresentScreen(ad: TWMAd) {
        listener.onAdImpression()
    }

    override fun onReceiveAd(ad: TWMAd) {
        when (ad is TWMNativeAd) {
            true -> {
                val mapper = TAmediaNativeAdMapper(ad)
                listener.onAdLoaded(mapper)
            }
            false -> {
                listener.onAdFailedToLoad(AdRequest.ERROR_CODE_NO_FILL)
            }
        }
    }


}