@file:Suppress("DEPRECATION")

package com.taiwanmobile.pt.gam.mediation

import android.graphics.drawable.Drawable
import android.net.Uri
import com.google.android.gms.ads.formats.NativeAd

/**
 * A Image class that fits the the [NativeAd.Image] abstract class and can be filled with
 * assets returned by TAmedia SDK.
 */
class TAmediaGAMNativeMappedImage(
    private val drawable: Drawable,
    private val uri: Uri
) : NativeAd.Image() {
    override fun getDrawable(): Drawable = drawable
    override fun getUri(): Uri = uri
    override fun getScale(): Double = 1.0
}